---
title: Preferences
slug: Mozilla/Developer_guide/Preferences
---
<p>This document attempts to explaing the guide line of naming rules of preferences and accessing them.</p>

<div class="warning">
<p>This document is still under discussion.</p>
</div>

<h2 id="Naming_guidelines">Naming guidelines</h2>

<p>By convention, preference names are period separated. Preferences for a feature are grouped together with a common prefix. For example:</p>

<pre>foo.bar.enabled
foo.bar.baz_range.min
foo.bar.baz_range.max
</pre>

<p>If code may want to observe preference changes for a group of preferences, they should be grouped together with a common prefix to improve observer performane.</p>

<p>Preferences which enable or disable a feature should be named &lt;root&gt;.featurename.enabled with a boolean type. If an <code>"enabled"</code> pref does not always enable or disable the feature, you may need to add another pref which enables or disables the feature forcibly (i.e., ignoring the condition). The pref name should be <code>"force_disable"</code> or <code>"force_enable"</code>.</p>

<p>Preference names should be easy to understand. It's better to use a long name such as <code>"use_it_only_when_it_is_available"</code> than a cryptic name which might cause confusion.</p>

<h2 id="When_to_use_preferences">When to use preferences</h2>

<p>Prefs may/should be used in the following situations:</p>

<ul>
 <li>To store a user-visible preference setting. Preferences of this type require UX review.</li>
 <li>To enable release drivers to turn a feature off easily if there is a problem found during the release process. Once a feature has shipped, this preference type should probably be removed.</li>
 <li>To control features which are experimental or not ready to ship to our release users. Per-channel defaults control which experimental features are enabled for each prerelease population.</li>
 <li>Other internal usage: for example to facilitate A/B testing via telemetry experiments, or to control automated test behavior. In these cases consider whether it would be better to use a runtime setting instead of a persistent preference to control the behavior.</li>
</ul>

<p>Preferences should <em>not</em> be used to expose features to power users via about:config settings. In order to make support better, it is far better for these users to install an addon to change the default behavior, even if the addon changes a runtime flag. This allows us to see non-default settings in about:support, Firefox Health Report, and crash-stats, and they are properly disabled when running in Firefox safe mode.</p>

<h2 id="How_to_add_new_preference">How to add new preference</h2>

<p>If a preference is used by core platform/Gecko code, a default value should normally be added to {{Source("modules/libpref/init/all.js")}}. This default is shared all Mozilla products such as Firefox, Thunderbird, Firefox for Android and Firefox OS. If you need to set different initial value for specific product, you can use {{Source("browser/app/profile/firefox.js")}}, <a href="http://mxr.mozilla.org/comm-central/source/mailnews/mailnews.js">mailnews/mailnews.js</a>, {{Source("mobile/android/app/mobile.js")}} and/or {{Source("b2g/app/b2g.js")}}.</p>

<p>If a preference is used only by application-specific code, the default should live in the relevant app-specific default file.</p>

<h3 id="Guidelines_of_getting_preference_in_C_code">Guidelines of getting preference in C++ code</h3>

<p>When you're hacking internal code of libxul, you can use API defined in {{Source("modules/libpref/public/Preferences.h")}}.</p>

<p>If you need to get a preference value at very hot path, you shouldn't use <code>Preferences::Get*()</code>. Instead of that there are two kinds of API sets.</p>

<p>One is <code>Preferences::Add*VarCache()</code>. This API modifies registed static variable to the latest preference value automatically. Therefore, this is very useful if you don't need to reinitialize someting when the pref is changed.</p>

<p>The other is <code>Preferences::RegisterCallback()</code>. You can register a call back method for preferences which you want to observe the changes. If you use this, you need to call <code>Preferences::UnregisterCallback()</code> when you don't need it anymore. If you need a whole time while our process is running, you should call it at shutting down XPCOM. Most modules have an observer of XPCOM shudown and calls <code>Shutdown()</code> method of a lot of classes. See <code>nsLayoutStatics::Shutdown()</code> ({{Source("layout/build/nsLayoutStatics.cpp")}}) for the example.</p>

<h2 id="Float_values">Float values</h2>

<p>The prerefences system doesn't support float types natively. One workaround is to use integer preference whose value is mutilplied by 10, 100 or 1000. You should explain the value meaning in {{Source("modules/libpref/src/init/all.js")}} if you define its initial value. The other is to use string preference and convert to float using <code>parseFloat</code> (JavaScript) or <code>atof</code> (C++).</p>
